# Create a unit name - Ruff Mod
#
# Combination of several modcomps ...
#   - random unit name from TheLopez
#   - variation on '# unit of city x by Porges' by Ruff_Hi
#
# Random Unit Name Mod
# CvCustomEventManager
# 
#-------------------------------------------------------------------
# Reorganized to work via CvCustomEventManager
# using HOFLogger as template.
# CvCustomEventManager & Civ4lerts by Gillmer J. Derge
#-------------------------------------------------------------------

from CvPythonExtensions import *
import CvUtil
import Popup as PyPopup
import PyHelpers
import RandomNameUtils
import UnitNameRuff
import RuffModControl

gc = CyGlobalContext()
PyPlayer = PyHelpers.PyPlayer
PyInfo = PyHelpers.PyInfo

RuffMod = RuffModControl.RuffModConfig()

class UnitNameEventManager:

	def __init__(self, eventManager):

		BuildUnitName(eventManager)

class AbstractBuildUnitName(object):

	def __init__(self, eventManager, *args, **kwargs):
		super(AbstractBuildUnitName, self).__init__(*args, **kwargs)

class BuildUnitName(AbstractBuildUnitName):

	def __init__(self, eventManager, *args, **kwargs):
		super(BuildUnitName, self).__init__(eventManager, *args, **kwargs)

		eventManager.addEventHandler("unitBuilt", self.onUnitBuilt)

		self.eventMgr = eventManager

	def onUnitBuilt(self, argsList):
		'Unit Completed'

		city = argsList[0]
		unit = argsList[1]

		iOwner = gc.getPlayer(unit.getOwner())
		civtype = iOwner.getCivilizationType()

		if (iOwner.isHuman()):
			ziNameMthd = RuffMod.get_int('UNITNAME', 'Method', 0)
			if ziNameMthd == 0:
				return
			elif ziNameMthd == 1:
				zsName = RandomNameUtils.getRandomName()
			elif ziNameMthd == 2:
				znName = RandomNameUtils.getRandomCivilizationName(civtype)
			elif ziNameMthd == 3:
				zsName = UnitNameRuff.getUnitNameNoCity(unit)
			elif ziNameMthd == 4:
				zsName = UnitNameRuff.getUnitNameWithCity(unit, city)
			elif ziNameMthd == 5:
				zsName = UnitNameRuff.getUnitBorgName()
			else:
				return

			unit.setName(zsName)
