# Unit Naming by Ruff_Hi
#
# v 1.0
#
# Roman Number convert stolen from sen2000

from CvPythonExtensions import *

import CvUtil
import sys
import math
import PyHelpers
#import CvConfigParser
import random
import Roman
import RuffModControl
import RuffEcho

#######SD Tool Kit#######

import SdToolKit
sdEcho         = SdToolKit.sdEcho
sdModInit      = SdToolKit.sdModInit
sdModLoad      = SdToolKit.sdModLoad
sdModSave      = SdToolKit.sdModSave
sdEntityInit   = SdToolKit.sdEntityInit
sdEntityExists = SdToolKit.sdEntityExists
sdEntityWipe   = SdToolKit.sdEntityWipe
sdGetVal       = SdToolKit.sdGetVal
sdSetVal       = SdToolKit.sdSetVal

############################

PyPlayer = PyHelpers.PyPlayer
PyInfo = PyHelpers.PyInfo
RuffMod = RuffModControl.RuffModConfig()
zsModName = "UnitNaming"
REcho = RuffEcho.RuffEcho

def getUnitNameNoCity(objUnit):
   	unitS = PyInfo.UnitInfo(objUnit.getUnitType()).getDescription()

	if (sdEntityExists(zsModName, unitS) == False):
		#Since no record create entries
		unitCount_Dic = {'Cnt':0}
		sdEntityInit(zsModName, unitS, unitCount_Dic)

	unitCount = sdGetVal(zsModName, unitS, "Cnt")
	unitCount = unitCount + 1
	sdSetVal(zsModName, unitS, "Cnt", unitCount)

	if RuffMod.get_boolean('UNITNAME', 'Roman', False):
		unitName = unitS + " " + Roman.toRoman(unitCount)
	else:
		unitName = findOrdinal(unitCount) + " " + unitS

	return unitName

def getUnitNameWithCity(objUnit, objCity):
   	unitS = PyInfo.UnitInfo(objUnit.getUnitType()).getDescription()
   	cityS = objCity.getName()

   	unitcityS = unitS + cityS

	if (sdEntityExists(zsModName, unitcityS) == False):
		#Since no record create entries
		unitCount_Dic = {'Cnt':0}
		sdEntityInit(zsModName, unitcityS, unitCount_Dic)

	unitCount = sdGetVal(zsModName, unitcityS, "Cnt")
	unitCount = unitCount + 1
	sdSetVal(zsModName, unitcityS, "Cnt", unitCount)

	if RuffMod.get_boolean('UNITNAME', 'Roman', False):
		unitName = unitS + " " + Roman.toRoman(unitCount) + " of " + cityS
	else:
		unitName = findOrdinal(unitCount) + " " + unitS + " of " + cityS
	return unitName

def findOrdinal(num):
    t = 'th st nd rd th th th th th th'.split()
    if num % 100 in (11, 12, 13): #special case
        return '%dth' % num
    return str(num) + t[num % 10]

def getUnitBorgName():
	zsKey = "Borg"

	if (sdEntityExists(zsModName, zsKey) == False):
		#Since no record create entries
		unitTotal = random.randint(6, 10)
		Unit_Dic = {'Cnt':0, 'Ttl':unitTotal, 'Unimatrix':0}
		sdEntityInit(zsModName, zsKey, Unit_Dic)

	zsAdjuncts = ('Primary', 'Secondary', 'Tertiary')

	unitCount = sdGetVal(zsModName, zsKey, "Cnt")
	unitTotal = sdGetVal(zsModName, zsKey, "Ttl")
	unitUnimatrix = sdGetVal(zsModName, zsKey, "Unimatrix")

	unitCount = unitCount + 1
	if unitCount > unitTotal:
		unitCount = 1
		unitTotal = random.randint(6, 10)
		unitUnimatrix = unitUnimatrix + 1

	sdSetVal(zsModName, zsKey, "Cnt", unitCount)
	sdSetVal(zsModName, zsKey, "Ttl", unitTotal)
	sdSetVal(zsModName, zsKey, "Unimatrix", unitUnimatrix)

	unitName = "%i of %i, Unimatrix %i" %(unitCount, unitTotal, unitUnimatrix)

	return unitName
